diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java b/src/main/java/net/minecraft/client/gui/modelviewer/ModelViewerScreen.java
similarity index 69%
rename from src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
rename to src/main/java/net/minecraft/client/gui/modelviewer/ModelViewerScreen.java
index 15ef85781..388d47ef9 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/ModelViewerScreen.java
@@ -1,18 +1,19 @@
 package net.minecraft.client.gui.modelviewer;
 
 import com.b100.utils.ImageUtils;
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiPhotoMode;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.PhotoModeScreen;
 import net.minecraft.client.gui.modelviewer.categories.BlockCategory;
 import net.minecraft.client.gui.modelviewer.categories.EntityCategory;
 import net.minecraft.client.gui.modelviewer.categories.ModelViewerCategory;
 import net.minecraft.client.gui.modelviewer.categories.ParticleCategory;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
+import net.minecraft.client.gui.modelviewer.elements.ListenerSliderElement;
+import net.minecraft.client.gui.modelviewer.elements.ListenerTextFieldElement;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
-import net.minecraft.client.gui.options.GuiOptions;
+import net.minecraft.client.gui.options.OptionsScreen;
 import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.shader.PhotoModeRenderer;
@@ -30,6 +31,7 @@ import net.minecraft.core.util.helper.Utils;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
+import org.slf4j.Logger;
 
 import java.io.File;
 import java.nio.ByteBuffer;
@@ -49,21 +51,22 @@ import static org.lwjgl.opengl.GL11.glGetError;
 import static org.lwjgl.opengl.GL11.glGetTexImage;
 import static org.lwjgl.opengl.GL11.glGetTexLevelParameteri;
 
-public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField.ITextChangeListener {
-    private GuiListenerButton buttonRotateLeft;
-    private GuiListenerButton buttonRotateRight;
-    private GuiListenerButton buttonCenterScreen;
-    private GuiListenerButton buttonTakeScreenshot;
-    private GuiListenerButton buttonOpenScreenshotFolder;
-    private GuiListenerButton buttonExit;
-    private GuiListenerSlider sliderTilt;
-    private GuiListenerButton buttonShaders;
-    private GuiListenerSlider sliderIntensity;
-    public GuiListenerButton buttonPrevEntry;
-    public GuiListenerButton buttonNextEntry;
-    private GuiListenerButton buttonCategory;
-    private GuiListenerButton buttonReloadTextures;
-    private GuiListenerButton buttonTickToggle;
+public class ModelViewerScreen extends PhotoModeScreen implements ListenerTextFieldElement.ITextChangeListener {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private ListenerButtonElement buttonRotateLeft;
+    private ListenerButtonElement buttonRotateRight;
+    private ListenerButtonElement buttonCenterScreen;
+    private ListenerButtonElement buttonTakeScreenshot;
+    private ListenerButtonElement buttonOpenScreenshotFolder;
+    private ListenerButtonElement buttonExit;
+    private ListenerSliderElement sliderTilt;
+    private ListenerButtonElement buttonShaders;
+    private ListenerSliderElement sliderIntensity;
+    public ListenerButtonElement buttonPrevEntry;
+    public ListenerButtonElement buttonNextEntry;
+    private ListenerButtonElement buttonCategory;
+    private ListenerButtonElement buttonReloadTextures;
+    private ListenerButtonElement buttonTickToggle;
     private final ModelViewerCategory entityCategory = new EntityCategory(this);
     private final ModelViewerCategory particleCategory = new ParticleCategory(this);
     private final ModelViewerCategory blockCategory = new BlockCategory(this);
@@ -78,12 +81,12 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
 
     protected boolean tickProgress = true;
     protected boolean rotateToCamera = true;
-    public GuiModelViewer(){
+    public ModelViewerScreen(){
         this.mc = Minecraft.getMinecraft(this);
         mc.thePlayer.absMoveTo(0.5, 64.5, 0.5, 180, 0);
         mc.thePlayer.noPhysics = true;
-        mc.renderEngine.refreshTexturesAndDisplayErrors();
-        mc.renderEngine.updateDynamicTextures(false);
+        mc.textureManager.refreshTexturesAndDisplayErrors();
+        mc.textureManager.updateDynamicTextures(false);
 
         if(Shaders.enableShaders) {
             photoModeRenderer = new PhotoModeRenderer(mc, this);
@@ -106,61 +109,61 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
     @Override
     public void init()
     {
-        controlList.clear();
+        buttons.clear();
         I18n i18n = I18n.getInstance();
 
-        List<GuiButton> leftSideButtons = new ArrayList<>();
+        List<ButtonElement> leftSideButtons = new ArrayList<>();
 
-        buttonExit = new GuiListenerButton(5, 0, height - 20, 20, 20, "X");
+        buttonExit = new ListenerButtonElement(5, 0, height - 20, 20, 20, "X");
         buttonExit.setActionListener(this::exitToMenu);
 
-        buttonRotateLeft = new GuiListenerButton(0, width / 2 - 49 - 2 - 20, height - 20, 20, 20, "<");
+        buttonRotateLeft = new ListenerButtonElement(0, width / 2 - 49 - 2 - 20, height - 20, 20, 20, "<");
         buttonRotateLeft.setActionListener(() -> {
             iRotationGoal += 1;
             iRotationGoal = (int) iRotationGoal;
         });
-        buttonRotateRight = new GuiListenerButton(1, width / 2 + 49 + 2, height - 20, 20, 20, ">");
+        buttonRotateRight = new ListenerButtonElement(1, width / 2 + 49 + 2, height - 20, 20, 20, ">");
         buttonRotateRight.setActionListener(() -> {
             iRotationGoal -= 1;
             iRotationGoal = (int) iRotationGoal;
         });
-        buttonTakeScreenshot = new GuiListenerButton(4, width / 2 - 49, height - 20, 98, 20, i18n.translateKey("gui.photo_mode.button.take_screenshot"));
+        buttonTakeScreenshot = new ListenerButtonElement(4, width / 2 - 49, height - 20, 98, 20, i18n.translateKey("gui.photo_mode.button.take_screenshot"));
         buttonTakeScreenshot.setActionListener(this::screenShot);
 
-        buttonPrevEntry = new GuiListenerButton(10, width / 2 - 49 - 2 - 20, height - 40 - 2, 20, 20, "<");
+        buttonPrevEntry = new ListenerButtonElement(10, width / 2 - 49 - 2 - 20, height - 40 - 2, 20, 20, "<");
         buttonPrevEntry.setActionListener(() -> currentCategory.cycleCategoryEntry(-1));
-        buttonNextEntry = new GuiListenerButton(11, width / 2 + 49 + 2, height - 40 - 2, 20, 20, ">");
+        buttonNextEntry = new ListenerButtonElement(11, width / 2 + 49 + 2, height - 40 - 2, 20, 20, ">");
         buttonNextEntry.setActionListener(() -> currentCategory.cycleCategoryEntry(1));
-        buttonCategory = new GuiListenerButton(12, width / 2 - 49, height - 40 - 2, 98, 20, i18n.translateKey(currentCategory.getCategoryNameKey()));
+        buttonCategory = new ListenerButtonElement(12, width / 2 - 49, height - 40 - 2, 98, 20, i18n.translateKey(currentCategory.getCategoryNameKey()));
         buttonCategory.setActionListener(() -> setCategory(categories.get((categories.indexOf(currentCategory) + 1) % categories.size())));
         buttonCategory.setOnValueChanged(() -> buttonCategory.displayString = i18n.translateKey(currentCategory.getCategoryNameKey()));
 
-        buttonReloadTextures = new GuiListenerButton(12, 21, height - 20, 98, 20, i18n.translateKey("gui.model_viewer.button.reload_textures"));
-        buttonReloadTextures.setActionListener(() -> mc.renderEngine.refreshTexturesAndDisplayErrors());
-        buttonOpenScreenshotFolder = (GuiListenerButton) new GuiListenerButton(30, buttonReloadTextures.getWidth() + buttonReloadTextures.getX() + 1, buttonReloadTextures.getY(), 20, 20, "")
+        buttonReloadTextures = new ListenerButtonElement(12, 21, height - 20, 98, 20, i18n.translateKey("gui.model_viewer.button.reload_textures"));
+        buttonReloadTextures.setActionListener(() -> mc.textureManager.refreshTexturesAndDisplayErrors());
+        buttonOpenScreenshotFolder = (ListenerButtonElement) new ListenerButtonElement(30, buttonReloadTextures.getWidth() + buttonReloadTextures.getX() + 1, buttonReloadTextures.getY(), 20, 20, "")
             .setTextures("minecraft:gui/misc/button_folder", "minecraft:gui/misc/button_folder_highlighted", "minecraft:gui/misc/button_folder");
         buttonOpenScreenshotFolder.setActionListener(() -> Utils.openDirectory(new File(mc.getMinecraftDir(), "")));
 
-        buttonCenterScreen = new GuiListenerButton(10, 0, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.center_camera"));
+        buttonCenterScreen = new ListenerButtonElement(10, 0, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.center_camera"));
         buttonCenterScreen.setActionListener(() -> {
             iPanXGoal = 0;
             iPanYGoal = 0;
         });
 
-        buttonTickToggle = new GuiListenerButton(13, width - 120, 0, 99, 20, i18n.translateKeyAndFormat("gui.model_viewer.button.tickprogress", tickProgress));
+        buttonTickToggle = new ListenerButtonElement(13, width - 120, 0, 99, 20, i18n.translateKeyAndFormat("gui.model_viewer.button.tickprogress", tickProgress));
         buttonTickToggle.setActionListener(() -> tickProgress = !tickProgress);
         buttonTickToggle.setOnValueChanged(() -> buttonTickToggle.displayString = i18n.translateKeyAndFormat("gui.model_viewer.button.tickprogress", tickProgress));
 
-        GuiListenerButton cameraRotateButton = new GuiListenerButton(-1, width - 120, 0, 120, 20, i18n.translateKeyAndFormat("gui.model_viewer.button.rotate", rotateToCamera));
+        ListenerButtonElement cameraRotateButton = new ListenerButtonElement(-1, width - 120, 0, 120, 20, i18n.translateKeyAndFormat("gui.model_viewer.button.rotate", rotateToCamera));
         cameraRotateButton.setActionListener(() -> {
             rotateToCamera = !rotateToCamera;
             cameraRotateButton.displayString = i18n.translateKeyAndFormat("gui.model_viewer.button.rotate", rotateToCamera);
         });
 
-        GuiListenerButton buttonManualTick = new GuiListenerButton(14, width - 21, 0, 20, 20, "+");
+        ListenerButtonElement buttonManualTick = new ListenerButtonElement(14, width - 21, 0, 20, 20, "+");
         buttonManualTick.setActionListener(this::entryTick);
 
-        sliderTilt = new GuiListenerSlider(7, 0, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.tilt.default"), iTiltGoal / 90f);
+        sliderTilt = new ListenerSliderElement(7, 0, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.tilt.default"), iTiltGoal / 90f);
         sliderTilt.setOnValueChanged(() ->{
             // Update tilt slider
             String tilt = i18n.translateKey("gui.photo_mode.button.tilt.default");
@@ -175,7 +178,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
             }
         });
         if(Shaders.enableShaders) {
-            buttonShaders = new GuiListenerButton(8, 0, 0, 120, 20, i18n.translateKeyAndFormat("gui.photo_mode.button.shader", i18n.translateKey("gui.photo_mode.button.shader.none")));
+            buttonShaders = new ListenerButtonElement(8, 0, 0, 120, 20, i18n.translateKeyAndFormat("gui.photo_mode.button.shader", i18n.translateKey("gui.photo_mode.button.shader.none")));
             buttonShaders.setActionListener(() -> {
                 boolean ctrl = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
                 if (ctrl)
@@ -194,7 +197,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
                 activeShader = activeShader.toUpperCase(Locale.ROOT);
                 buttonShaders.displayString = i18n.translateKeyAndFormat("gui.photo_mode.button.shader", activeShader);
             });
-            sliderIntensity = new GuiListenerSlider(9, 0, 0, 120, 20, i18n.translateKeyAndFormat("gui.photo_mode.button.intensity", (int)(intensityValue * 100) + "%"), intensityValue);
+            sliderIntensity = new ListenerSliderElement(9, 0, 0, 120, 20, i18n.translateKeyAndFormat("gui.photo_mode.button.intensity", (int)(intensityValue * 100) + "%"), intensityValue);
             sliderIntensity.setOnValueChanged(() ->{
                 // Update intensity slider
                 sliderIntensity.displayString = i18n.translateKeyAndFormat("gui.photo_mode.button.intensity", (int)(sliderIntensity.sliderValue * 100) + "%");
@@ -212,19 +215,19 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
             mc.setRenderer(photoModeRenderer);
         }
 
-        controlList.add(cameraRotateButton);
-        controlList.add(buttonTickToggle);
+        buttons.add(cameraRotateButton);
+        buttons.add(buttonTickToggle);
 
         int i=0;
-        List<GuiButton> _buttons = new ArrayList<>(controlList);
-        for(GuiButton button : _buttons) {
+        List<ButtonElement> _buttons = new ArrayList<>(buttons);
+        for(ButtonElement button : _buttons) {
             button.yPosition = i++ * 21;
         }
 
-        controlList.add(buttonManualTick);
+        buttons.add(buttonManualTick);
         buttonManualTick.yPosition = buttonTickToggle.yPosition;
 
-        currentCategory.addContextButtons(controlList);
+        currentCategory.addContextButtons(buttons);
 
         leftSideButtons.add(buttonCenterScreen);
         leftSideButtons.add(sliderTilt);
@@ -235,13 +238,13 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
         }
 
         int j = 0;
-        for (GuiButton button: leftSideButtons){
+        for (ButtonElement button: leftSideButtons){
             button.yPosition = j++ * 21;
         }
 
-        controlList.addAll(leftSideButtons);
+        buttons.addAll(leftSideButtons);
 
-        GuiListenerTextField rField = new GuiListenerTextField(this, fontRenderer, 0, j++ * 21, 40, 20, String.valueOf(bgRed), "Red");
+        ListenerTextFieldElement rField = new ListenerTextFieldElement(this, font, 0, j++ * 21, 40, 20, String.valueOf(bgRed), "Red");
         rField.setPrefaceText("R: ");
         rField.setKeyListener(key -> {
             try {
@@ -254,7 +257,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
                 bgRed = defaultRed;
             }
         });
-        GuiListenerTextField gField = new GuiListenerTextField(this, fontRenderer, 40, rField.yPosition, 40, 20, String.valueOf(bgGreen), "Green");
+        ListenerTextFieldElement gField = new ListenerTextFieldElement(this, font, 40, rField.yPosition, 40, 20, String.valueOf(bgGreen), "Green");
         gField.setPrefaceText("G: ");
         gField.setKeyListener(key -> {
             try {
@@ -267,7 +270,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
                 bgGreen = defaultGreen;
             }
         });
-        GuiListenerTextField bField = new GuiListenerTextField(this, fontRenderer, 80, rField.yPosition, 40, 20, String.valueOf(bgBlue), "Blue");
+        ListenerTextFieldElement bField = new ListenerTextFieldElement(this, font, 80, rField.yPosition, 40, 20, String.valueOf(bgBlue), "Blue");
         bField.setPrefaceText("B: ");
         bField.setKeyListener(key -> {
             try {
@@ -281,19 +284,19 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
             }
         });
 
-        controlList.add(rField);
-        controlList.add(gField);
-        controlList.add(bField);
-
-        controlList.add(buttonRotateLeft);
-        controlList.add(buttonRotateRight);
-        controlList.add(buttonTakeScreenshot);
-        controlList.add(buttonOpenScreenshotFolder);
-        controlList.add(buttonPrevEntry);
-        controlList.add(buttonNextEntry);
-        controlList.add(buttonCategory);
-        controlList.add(buttonReloadTextures);
-        controlList.add(buttonExit);
+        buttons.add(rField);
+        buttons.add(gField);
+        buttons.add(bField);
+
+        buttons.add(buttonRotateLeft);
+        buttons.add(buttonRotateRight);
+        buttons.add(buttonTakeScreenshot);
+        buttons.add(buttonOpenScreenshotFolder);
+        buttons.add(buttonPrevEntry);
+        buttons.add(buttonNextEntry);
+        buttons.add(buttonCategory);
+        buttons.add(buttonReloadTextures);
+        buttons.add(buttonExit);
     }
     private void setCategory(ModelViewerCategory category){
         if (currentCategory != null){
@@ -313,7 +316,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
         return id;
     }
     @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick)
+    public void render(int xm, int ym, float partialTick)
     {
         GL11.glViewport(0, 0, mc.resolution.width, mc.resolution.height);
         GL11.glMatrixMode(GL11.GL_PROJECTION);
@@ -371,34 +374,34 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
 
         buttonCenterScreen.enabled = (iPanX != 0 || iPanY != 0) && !(iPanXGoal == 0 && iPanYGoal == 0);
 
-        List<GuiButton> _buttons = new ArrayList<>(controlList);
-        for (GuiButton guibutton : _buttons) {
-            guibutton.drawButton(mc, mouseX, mouseY);
+        List<ButtonElement> _buttons = new ArrayList<>(buttons);
+        for (ButtonElement button : _buttons) {
+            button.drawButton(mc, xm, ym);
         }
 
         scroll(Mouse.getDWheel());
 
         BlockEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, new BlockEntity(), -0.5D, -0.75D, -0.5D, partialTick);
 
-        drawStringCentered(fontRenderer, currentCategory.getCurrentDisplayInfo(I18n.getInstance()), width/2, 1, 0xffffff);
+        drawStringCentered(font, currentCategory.getCurrentDisplayInfo(I18n.getInstance()), width/2, 1, 0xffffff);
     }
     @Override
-    public void keyTyped(char c, int key, int mouseX, int mouseY)
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
-        if (key == Keyboard.KEY_ESCAPE) {
+        if (eventKey == Keyboard.KEY_ESCAPE) {
             exitToMenu();
         }
-        List<GuiButton> _buttons = new ArrayList<>(controlList);
-        for (GuiButton button : _buttons){
-            if (button instanceof IListenerElement && button.isHovered(mouseX, mouseY)){
-                ((IListenerElement) button).onKeyTyped(c, key);
+        List<ButtonElement> _buttons = new ArrayList<>(buttons);
+        for (ButtonElement button : _buttons){
+            if (button instanceof IListenerElement && button.isHovered(mx, my)){
+                ((IListenerElement<?>) button).onKeyTyped(eventCharacter, eventKey);
             }
         }
     }
     private void exitToMenu(){
         currentCategory.onClose();
         mc.changeWorld(null);
-        mc.displayGuiScreen(new GuiOptions(null, OptionsPages.DEBUG));
+        mc.displayScreen(new OptionsScreen(null, OptionsPages.DEBUG));
     }
     public static int cycleBlockId(int id, int idOff){
         int id2 = (id + Block.blocksList.length + idOff) % Block.blocksList.length;
@@ -408,7 +411,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
         return id2;
     }
     @Override
-    public void onClosed() {
+    public void removed() {
         if(Shaders.enableShaders) {
             mc.setRenderer(previousRenderer);
         }
@@ -418,10 +421,10 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
     public void tick()
     {
         super.tick();
-        List<GuiButton> _buttons = new ArrayList<>(controlList);
-        for (GuiButton button : _buttons){
-            if (button instanceof GuiListenerButton){
-                ((GuiListenerButton) button).tick();
+        List<ButtonElement> _buttons = new ArrayList<>(buttons);
+        for (ButtonElement button : _buttons){
+            if (button instanceof ListenerButtonElement){
+                ((ListenerButtonElement) button).tick();
             }
         }
         if (tickProgress){
@@ -430,20 +433,20 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
         Minecraft.doPartialTick = tickProgress;
     }
     private void entryTick(){
-        mc.renderEngine.updateDynamicTextures(false);
-        mc.effectRenderer.updateEffects();
+        mc.textureManager.updateDynamicTextures(false);
+        mc.particleEngine.tick();
         currentCategory.onTick();
         // TODO this fixes world time based animation, but also ticks things like wind and im not certain on the best way to set wind direction arbitrarily right now
 //        mc.theWorld.getLevelData().setWorldTime(mc.theWorld.getWorldTime() + 1);
     }
     @Override
-    protected void buttonPressed(GuiButton button) {
+    protected void buttonClicked(ButtonElement button) {
         // Overrides the regular GuiPhotomode's method
     }
 
     public long timeLastKeyPressed = System.currentTimeMillis();
     @Override
-    public void textChanged(GuiListenerTextField textField) {
+    public void textChanged(ListenerTextFieldElement textField) {
         timeLastKeyPressed = System.currentTimeMillis();
     }
     public float[] getBackgroundFogColor(){
@@ -453,6 +456,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
     public void screenShot(){
         try {
             File screenshotsDir = new File(mc.getMinecraftDir(), "screenshots");
+            //noinspection ResultOfMethodCallIgnored
             screenshotsDir.mkdir();
             Texture texture = ((ShadersRenderer)mc.renderer).getWorldFramebufferTex();
             texture.bind();
@@ -477,10 +481,10 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
                 ImageUtils.saveExternalImage(Textures.getImage(buffer, w, h, true, true), outPut);
 
             }else {
-                System.out.println("Cannot get pixel data");
+                LOGGER.warn("Cannot get pixel data for screenshot!");
             }
         } catch (Exception e){
-            e.printStackTrace();
+            LOGGER.error("Exception while trying to take Model Viewer ScreenShot", e);
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java
index 171038428..f35573bcb 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/BlockCategory.java
@@ -1,13 +1,13 @@
 package net.minecraft.client.gui.modelviewer.categories;
 
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
 import net.minecraft.client.gui.modelviewer.categories.entries.block.BasicBlockEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.block.BlockEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.block.JarEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.block.MobSpawnerEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.block.SignEntry;
-import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.ItemEntity;
@@ -22,9 +22,9 @@ import java.util.List;
 
 public class BlockCategory extends ModelViewerCategory {
     public HashMap<Block, BlockEntry> entryHashMap = new HashMap<>();
-    public GuiTextCycle<Integer> blockIdTextField;
-    public GuiTextCycle<Integer> blockMetaTextField;
-    public BlockCategory(GuiModelViewer modelViewer) {
+    public TextCycleElement<Integer> blockIdTextField;
+    public TextCycleElement<Integer> blockMetaTextField;
+    public BlockCategory(ModelViewerScreen modelViewer) {
         super(modelViewer);
         createEntries();
     }
@@ -59,8 +59,8 @@ public class BlockCategory extends ModelViewerCategory {
     }
 
     @Override
-    public void addContextButtons(List<GuiButton> buttonList) {
-        GuiButton lastButton = buttonList.get(buttonList.size()-1);
+    public void addContextButtons(List<ButtonElement> buttonList) {
+        ButtonElement lastButton = buttonList.get(buttonList.size()-1);
 
         modelViewer.buttonNextEntry.enabled = false;
         modelViewer.buttonPrevEntry.enabled = false;
@@ -69,10 +69,10 @@ public class BlockCategory extends ModelViewerCategory {
         if (blockIdTextField != null){
             wasFocused = blockIdTextField.textField.isFocused;
         }
-        blockIdTextField = new GuiTextCycle<Integer>(modelViewer, mc.fontRenderer, modelViewer.width - 120, lastButton.yPosition + 21, 120, 20, DisplayChunk.displayBlockId) {
+        blockIdTextField = new TextCycleElement<Integer>(modelViewer, mc.font, modelViewer.width - 120, lastButton.yPosition + 21, 120, 20, DisplayChunk.displayBlockId) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
-                return GuiModelViewer.cycleBlockId(current, offset);
+                return ModelViewerScreen.cycleBlockId(current, offset);
             }
 
             @Override
@@ -102,7 +102,7 @@ public class BlockCategory extends ModelViewerCategory {
         if (blockMetaTextField != null){
             wasFocused = blockMetaTextField.textField.isFocused;
         }
-        blockMetaTextField = new GuiTextCycle<Integer>(modelViewer, mc.fontRenderer, modelViewer.width - 120, blockIdTextField.yPosition + 21, 120, 20, 0) {
+        blockMetaTextField = new TextCycleElement<Integer>(modelViewer, mc.font, modelViewer.width - 120, blockIdTextField.yPosition + 21, 120, 20, 0) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
                 return (current + offset) & 0xFF;
@@ -134,9 +134,9 @@ public class BlockCategory extends ModelViewerCategory {
         BlockEntry entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
 
         if (entry != null){
-            List<GuiButton> list = entry.getEntryButtons(mc, modelViewer, mc.theWorld, DisplayChunk.displayBlockMeta);
+            List<ButtonElement> list = entry.getEntryButtons(mc, modelViewer, mc.theWorld, DisplayChunk.displayBlockMeta);
             if (list != null){
-                for (GuiButton button : list) {
+                for (ButtonElement button : list) {
                     button.setX(button.getX() + xPos);
                     button.setY(button.getY() + yPos);
                 }
@@ -195,7 +195,7 @@ public class BlockCategory extends ModelViewerCategory {
         if (_id != id){
             modelViewer.init();
         }
-        mc.effectRenderer.clearEffects(mc.theWorld);
+        mc.particleEngine.setWorld(mc.theWorld);
         mc.renderGlobal.loadRenderers();
     }
 }
